---
-- Image Path Function Test
--
-- Usage:
--   * :debug or the -d command line switch to enter debug mdoe.
--   * :lua wesnoth.image_test()
--
-- You may create an alias command as follows:
--   * :alias image_test=lua wesnoth.image_test()
--
-- For more information about image path functions, see:
--   http://wiki.wesnoth.org/ImagePathFunctionWML
---
 
helper = wesnoth.require "lua/helper.lua"
T = helper.set_wml_tag_metatable {}
 
local image_test_dialog = {
        --maximum_width = 800,
        --maximum_height = 600,
 
        T.helptip { id="tooltip_large" }, -- mandatory field
        T.tooltip { id="tooltip_large" }, -- mandatory field
 
T.grid {
      T.row {
           T.column {
                border = "all", border_size = 5,
                vertical_alignment = "top",
                horizontal_alignment = "right",
                T.label {
                      definition = "title",
                      label = "Create Image " .. " http://wiki.wesnoth.org/ImagePathFunctionWML" ,
                        }
                    },
            },
      T.row {
--------------------------------------------------
		T.column {
horizontal_alignment = "right",
horizontal_grow = true,
			T.grid {
				T.row {
---------------------------------------------------
           T.column {
               border = "all", border_size = 5,
               horizontal_alignment = "right",
		    horizontal_grow = true,
                   T.grid {
				T.row {
                          T.column {
                            T.spacer { }
						  },
				    T.column {
                            T.spacer { width = 700 }
						  },
					 },
--
				T.row {
                          T.column {
					  horizontal_grow = true,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Background Image:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "background",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = true,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Original Image:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "source",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_alignment = "right",
					  horizontal_grow = false,
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit1:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit1",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit2:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit2",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit3:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit3",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit4:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit4",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit5:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit5",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit6:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit6",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit7:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit7",
                                         }
                                   },
                             },
--
				T.row {
                          T.column {
					  horizontal_grow = false,
					  horizontal_alignment = "right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit8:"
                                      }
                                    },
                          T.column {
					  horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit8",
                                         }
                                   },
                             },
--
                           }
                     },
---------------------------------------------------
T.column {
               border = "all", border_size = 5,
               horizontal_alignment = "right",
			horizontal_grow = false,
			grow_factor = 1,
       T.panel {
              id = "image_panel",
              T.grid {
                  T.row {
                     T.column {
horizontal_grow = true,
vertical_grow = true,
					grow_factor = 1,
                            vertical_alignment = "center",
                            horizontal_alignment = "center",
                            T.image {
                                  id = "image"
                                    }
                               },
                      T.column {
                            T.spacer { height = 288 }
                               }
                           },
                    T.row {
                      T.column {
                            T.spacer { width = 288 }
                               },
                      T.column {
                            T.spacer {}
                               }
                          }
                         }
                       }
                     }

---------------------------------------------------
}
}
}
-------------------------------------
              },
        T.row {
             T.column {
                    grow_factor = 1,
                    horizontal_grow = true,
				horizontal_alignment="right",
                    T.grid {
				T.row {
                          T.column {
						T.spacer { width = 25 }
                                    },
                          T.column {
						T.spacer { width = 988 }
                                   }
					},
				T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit9:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit9",
                                         }
                                   }
					},
				T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit10:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit10",
                                         }
						  }
					},
				T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit11:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit11",
                                         }
                                   }
			            },
				T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Edit12:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "edit12",
                                         }
                                   }
                             },
                       T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Result Code:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "result_code",
                                         }
                                   }
                             },
                       T.row {
                          T.column {
                              grow_factor = 0,
                              horizontal_grow = false,
					  horizontal_alignment="right",
                              border = "all", border_size = 5,
                              T.label {
                                   label = "Quick Preview:"
                                      }
                                    },
                          T.column {
                              grow_factor = 1,
                              horizontal_grow = true,
                              border = "all", border_size = 5,
                              T.text_box {
                                   id = "quick_preview",
                                         }
                                   }
                             },
                           }
                     }
              },
        T.row {
             T.column {
                   T.spacer { width = 1024 }
                      }
              },
       T.row {
             T.column {
                   border = "all", border_size = 5,
			  horizontal_grow = true,
			  T.grid {
				T.row {
				   T.column {
						border = "all", border_size = 5,
						T.button {
							id = "cancel",
							label = "Close",
							    }
						  },
		              T.column {
		                      border = "all", border_size = 5,
		                      T.button {
		                            id = "clear",
		                            label = "Clear"
		                               }
		                       },
		              T.column {
		                      border = "all", border_size = 5,
		                      T.button {
		                            id = "show",
		                            label = "Show"
		                               },
		                       },
		              T.column {
		                      border = "all", border_size = 5,
		                      T.button {
		                            id = "preview",
		                            label = "Quick Preview"
		                               }
		                       },
					  }
				    }
                       }
                }
        }
}
 
-- Preserve the last value set on the dialog between runs in the same session.
local background = "misc/blank-hex.png~SCALE(300,300)" 
local source = "~BLIT(terrain/grass/green.png)" 
local edit1 = "~BLIT(images/misc/ellipse-leader-top.png~RC(ellipse_red>lightblue))"
local edit2 = "~BLIT(images/misc/ellipse-leader-bottom.png~RC(ellipse_red>lightblue))"
local edit3 = "~BLIT(units/human-peasants/peasant.png~RC(magenta>lightblue)" 
local edit4 = "~CROP(16,0,32,62)~FL(horiz),22,0)"
local edit5 = "~BLIT(projectiles/hatchet-2.png~CROP(20,20,30,30),35,5)" 
local edit6 = "~BLIT(projectiles/hatchet-2.png~CROP(20,20,30,30)~ROTATE(270),15,0)"
local edit7 = "~BLIT(projectiles/hatchet-2.png~CROP(20,20,30,30)~ROTATE(180),2,15)"
local edit8 = "~BLIT(projectiles/hatchet-2.png~CROP(20,20,30,30)~ROTATE(90),12,35)"
local edit9 = ""
local edit10 = ""
local edit11 = ""
local edit12 = ""
local quick_preview = "portraits/monsters/ogre.png~SCALE(130,130)"
 

--------------------------------------------------
function wesnoth.image_test1()
        local function do_show_image()
		background = wesnoth.get_dialog_value("background")
		source = wesnoth.get_dialog_value("source")
           edit1 = wesnoth.get_dialog_value("edit1")
		edit2 = wesnoth.get_dialog_value("edit2")
		edit3 = wesnoth.get_dialog_value("edit3")
		edit4 = wesnoth.get_dialog_value("edit4")
		edit5 = wesnoth.get_dialog_value("edit5")
		edit6 = wesnoth.get_dialog_value("edit6")
		edit7 = wesnoth.get_dialog_value("edit7")
		edit8 = wesnoth.get_dialog_value("edit8")
		edit9 = wesnoth.get_dialog_value("edit9")
		edit10 = wesnoth.get_dialog_value("edit10")
		edit11 = wesnoth.get_dialog_value("edit11")
		edit12 = wesnoth.get_dialog_value("edit12")

           wesnoth.set_dialog_value(background, "background")
           wesnoth.set_dialog_value(source, "source")
		wesnoth.set_dialog_value(edit1, "edit1")
		wesnoth.set_dialog_value(edit2, "edit2")
		wesnoth.set_dialog_value(edit3, "edit3")
		wesnoth.set_dialog_value(edit4, "edit4")
		wesnoth.set_dialog_value(edit5, "edit5")
		wesnoth.set_dialog_value(edit6, "edit6")
		wesnoth.set_dialog_value(edit7, "edit7")
		wesnoth.set_dialog_value(edit8, "edit8")
		wesnoth.set_dialog_value(edit9, "edit9")
		wesnoth.set_dialog_value(edit10, "edit10")
		wesnoth.set_dialog_value(edit11, "edit11")
		wesnoth.set_dialog_value(edit12, "edit12")

local result_code = background .. source .. edit1 .. edit2 .. edit3 .. edit4 .. edit5 .. edit6 .. edit7 .. edit8 .. edit9 .. edit10 .. edit11 .. edit12

		wesnoth.set_dialog_value(result_code, "result_code")
		wesnoth.set_dialog_value(result_code, "image")

        end
 -------------------------------
        local function do_clear()
           wesnoth.set_dialog_value("", "background")
           wesnoth.set_dialog_value("", "source")
		wesnoth.set_dialog_value("", "edit1")
		wesnoth.set_dialog_value("", "edit2")
		wesnoth.set_dialog_value("", "edit3")
		wesnoth.set_dialog_value("", "edit4")
		wesnoth.set_dialog_value("", "edit5")
		wesnoth.set_dialog_value("", "edit6")
		wesnoth.set_dialog_value("", "edit7")
		wesnoth.set_dialog_value("", "edit8")
		wesnoth.set_dialog_value("", "edit9")
		wesnoth.set_dialog_value("", "edit10")
		wesnoth.set_dialog_value("", "edit11")
		wesnoth.set_dialog_value("", "edit12")
                do_show_image()
        end
--------------------------------
        local function do_preview()
quick_preview = wesnoth.get_dialog_value("quick_preview")
wesnoth.set_dialog_value(quick_preview, "image")
        end
 -------------------------------
        local function preshow()
		wesnoth.set_dialog_value(background, "background")
           wesnoth.set_dialog_value(source, "source")
		wesnoth.set_dialog_value(edit1, "edit1")
		wesnoth.set_dialog_value(edit2, "edit2")
		wesnoth.set_dialog_value(edit3, "edit3")
		wesnoth.set_dialog_value(edit4, "edit4")
		wesnoth.set_dialog_value(edit5, "edit5")
		wesnoth.set_dialog_value(edit6, "edit6")
		wesnoth.set_dialog_value(edit7, "edit7")
		wesnoth.set_dialog_value(edit8, "edit8")
		wesnoth.set_dialog_value(edit9, "edit9")
		wesnoth.set_dialog_value(edit10, "edit10")
		wesnoth.set_dialog_value(edit11, "edit11")
		wesnoth.set_dialog_value(edit12, "edit12")
local result_code = background .. source .. edit1 .. edit2 .. edit3 .. edit4 .. edit5 .. edit6 .. edit7 .. edit8 .. edit9 .. edit10 .. edit11 .. edit12
		wesnoth.set_dialog_value(result_code, "result_code")
		wesnoth.set_dialog_value(result_code, "image")
		wesnoth.set_dialog_value(quick_preview, "quick_preview")
 
         wesnoth.set_dialog_callback(do_show_image, "show")
         wesnoth.set_dialog_callback(do_clear,      "clear")
         wesnoth.set_dialog_callback(do_preview,      "preview")

         wesnoth.set_dialog_canvas(1, {
                        T.rectangle {
                                x = 0,
                                y = 0,
                                w = "(width)",
                                h = "(height)",
                                fill_color = "0,0,0,64"
                        } }, "image_panel")


        end
 
        local function postshow()
                source = wesnoth.get_dialog_value("source")
        end
 
        local res
        repeat
-- Keep displaying the dialog until it is closed by means other than
-- pressing Enter, capturing path box updates on postshow accordingly.
 res = wesnoth.show_dialog(image_test_dialog, preshow, do_show_image)
 until res ~= -1
end

--For more information about image path codes, see http://wiki.wesnoth.org/ImagePathFunctionWML
